/* menu.c generated by valac 0.40.11, the Vala compiler
 * generated from menu.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 4 -*-
 *
 * Copyright (C) 2011,2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Andrea Cimitan <andrea.cimitan@canonical.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <cairo.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>


#define TYPE_MENU (menu_get_type ())
#define MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MENU, Menu))
#define MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MENU, MenuClass))
#define IS_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MENU))
#define IS_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MENU))
#define MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MENU, MenuClass))

typedef struct _Menu Menu;
typedef struct _MenuClass MenuClass;
typedef struct _MenuPrivate MenuPrivate;

#define TYPE_BACKGROUND (background_get_type ())
#define BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKGROUND, Background))
#define BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKGROUND, BackgroundClass))
#define IS_BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKGROUND))
#define IS_BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKGROUND))
#define BACKGROUND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKGROUND, BackgroundClass))

typedef struct _Background Background;
typedef struct _BackgroundClass BackgroundClass;
enum  {
	MENU_0_PROPERTY,
	MENU_BACKGROUND_PROPERTY,
	MENU_NUM_PROPERTIES
};
static GParamSpec* menu_properties[MENU_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define BACKGROUND_TYPE_DRAW_FLAGS (background_draw_flags_get_type ())

struct _Menu {
	GtkMenu parent_instance;
	MenuPrivate * priv;
};

struct _MenuClass {
	GtkMenuClass parent_class;
};

struct _MenuPrivate {
	Background* _background;
};

typedef enum  {
	BACKGROUND_DRAW_FLAGS_NONE,
	BACKGROUND_DRAW_FLAGS_GRID
} BackgroundDrawFlags;


static gpointer menu_parent_class = NULL;

GType menu_get_type (void) G_GNUC_CONST;
GType background_get_type (void) G_GNUC_CONST;
#define MENU_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MENU, MenuPrivate))
Menu* menu_new (Background* bg);
Menu* menu_construct (GType object_type,
                      Background* bg);
static gboolean menu_real_draw (GtkWidget* base,
                         cairo_t* c);
Background* menu_get_background (Menu* self);
GType background_draw_flags_get_type (void) G_GNUC_CONST;
void background_draw_full (Background* self,
                           cairo_t* c,
                           BackgroundDrawFlags flags);
static void menu_set_background (Menu* self,
                          Background* value);
static void menu_finalize (GObject * obj);
static void _vala_menu_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec);
static void _vala_menu_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec);


Menu*
menu_construct (GType object_type,
                Background* bg)
{
	Menu * self = NULL;
#line 25 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	g_return_val_if_fail (bg != NULL, NULL);
#line 27 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	self = (Menu*) g_object_new (object_type, "background", bg, NULL);
#line 25 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	return self;
#line 122 "menu.c"
}


Menu*
menu_new (Background* bg)
{
#line 25 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	return menu_construct (TYPE_MENU, bg);
#line 131 "menu.c"
}


static gboolean
menu_real_draw (GtkWidget* base,
                cairo_t* c)
{
	Menu * self;
	gboolean result = FALSE;
	Background* _tmp0_;
#line 30 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	self = (Menu*) base;
#line 30 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	g_return_val_if_fail (c != NULL, FALSE);
#line 32 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	_tmp0_ = self->priv->_background;
#line 32 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	if (_tmp0_ != NULL) {
#line 150 "menu.c"
		gint x = 0;
		gint y = 0;
		gint bg_x = 0;
		gint bg_y = 0;
		Background* _tmp1_;
		GdkWindow* _tmp2_;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		GdkWindow* _tmp5_;
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
		gint _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		Background* _tmp12_;
#line 36 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		_tmp1_ = self->priv->_background;
#line 36 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		_tmp2_ = gtk_widget_get_window ((GtkWidget*) _tmp1_);
#line 36 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		gdk_window_get_origin (_tmp2_, &_tmp3_, &_tmp4_);
#line 36 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		bg_x = _tmp3_;
#line 36 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		bg_y = _tmp4_;
#line 37 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		_tmp5_ = gtk_widget_get_window ((GtkWidget*) self);
#line 37 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		gdk_window_get_origin (_tmp5_, &_tmp6_, &_tmp7_);
#line 37 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		x = _tmp6_;
#line 37 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		y = _tmp7_;
#line 38 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		cairo_save (c);
#line 39 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		_tmp8_ = bg_x;
#line 39 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		_tmp9_ = x;
#line 39 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		_tmp10_ = bg_y;
#line 39 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		_tmp11_ = y;
#line 39 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		cairo_translate (c, (gdouble) (_tmp8_ - _tmp9_), (gdouble) (_tmp10_ - _tmp11_));
#line 40 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		_tmp12_ = self->priv->_background;
#line 40 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		background_draw_full (_tmp12_, c, BACKGROUND_DRAW_FLAGS_NONE);
#line 41 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		cairo_restore (c);
#line 203 "menu.c"
	}
#line 44 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	GTK_WIDGET_CLASS (menu_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_menu_get_type (), GtkMenu), c);
#line 45 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	result = FALSE;
#line 45 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	return result;
#line 211 "menu.c"
}


Background*
menu_get_background (Menu* self)
{
	Background* result;
	Background* _tmp0_;
#line 23 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	_tmp0_ = self->priv->_background;
#line 23 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	result = _tmp0_;
#line 23 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	return result;
#line 228 "menu.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 23 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	return self ? g_object_ref (self) : NULL;
#line 237 "menu.c"
}


static void
menu_set_background (Menu* self,
                     Background* value)
{
#line 23 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	g_return_if_fail (self != NULL);
#line 23 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	if (menu_get_background (self) != value) {
#line 249 "menu.c"
		Background* _tmp0_;
#line 23 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 23 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		_g_object_unref0 (self->priv->_background);
#line 23 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		self->priv->_background = _tmp0_;
#line 23 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		g_object_notify_by_pspec ((GObject *) self, menu_properties[MENU_BACKGROUND_PROPERTY]);
#line 259 "menu.c"
	}
}


static void
menu_class_init (MenuClass * klass)
{
#line 21 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	menu_parent_class = g_type_class_peek_parent (klass);
#line 21 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	g_type_class_add_private (klass, sizeof (MenuPrivate));
#line 21 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget *, cairo_t*)) menu_real_draw;
#line 21 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_menu_get_property;
#line 21 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_menu_set_property;
#line 21 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	G_OBJECT_CLASS (klass)->finalize = menu_finalize;
#line 21 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MENU_BACKGROUND_PROPERTY, menu_properties[MENU_BACKGROUND_PROPERTY] = g_param_spec_object ("background", "background", "background", TYPE_BACKGROUND, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 281 "menu.c"
}


static void
menu_instance_init (Menu * self)
{
#line 21 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	self->priv = MENU_GET_PRIVATE (self);
#line 23 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	self->priv->_background = NULL;
#line 292 "menu.c"
}


static void
menu_finalize (GObject * obj)
{
	Menu * self;
#line 21 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MENU, Menu);
#line 23 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	_g_object_unref0 (self->priv->_background);
#line 21 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	G_OBJECT_CLASS (menu_parent_class)->finalize (obj);
#line 306 "menu.c"
}


GType
menu_get_type (void)
{
	static volatile gsize menu_type_id__volatile = 0;
	if (g_once_init_enter (&menu_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MenuClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) menu_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Menu), 0, (GInstanceInitFunc) menu_instance_init, NULL };
		GType menu_type_id;
		menu_type_id = g_type_register_static (gtk_menu_get_type (), "Menu", &g_define_type_info, 0);
		g_once_init_leave (&menu_type_id__volatile, menu_type_id);
	}
	return menu_type_id__volatile;
}


static void
_vala_menu_get_property (GObject * object,
                         guint property_id,
                         GValue * value,
                         GParamSpec * pspec)
{
	Menu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MENU, Menu);
#line 21 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		case MENU_BACKGROUND_PROPERTY:
#line 21 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		g_value_set_object (value, menu_get_background (self));
#line 21 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		break;
#line 340 "menu.c"
		default:
#line 21 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		break;
#line 346 "menu.c"
	}
}


static void
_vala_menu_set_property (GObject * object,
                         guint property_id,
                         const GValue * value,
                         GParamSpec * pspec)
{
	Menu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MENU, Menu);
#line 21 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		case MENU_BACKGROUND_PROPERTY:
#line 21 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		menu_set_background (self, g_value_get_object (value));
#line 21 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		break;
#line 367 "menu.c"
		default:
#line 21 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/slick-greeter-1.2.4/src/menu.vala"
		break;
#line 373 "menu.c"
	}
}



