/* toggle-box.c generated by valac 0.40.11, the Vala compiler
 * generated from toggle-box.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 4 -*-
 *
 * Copyright (C) 2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Michael Terry <michael.terry@canonical.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <cairo.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>


#define TYPE_TOGGLE_BOX (toggle_box_get_type ())
#define TOGGLE_BOX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TOGGLE_BOX, ToggleBox))
#define TOGGLE_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TOGGLE_BOX, ToggleBoxClass))
#define IS_TOGGLE_BOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TOGGLE_BOX))
#define IS_TOGGLE_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TOGGLE_BOX))
#define TOGGLE_BOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TOGGLE_BOX, ToggleBoxClass))

typedef struct _ToggleBox ToggleBox;
typedef struct _ToggleBoxClass ToggleBoxClass;
typedef struct _ToggleBoxPrivate ToggleBoxPrivate;
enum  {
	TOGGLE_BOX_0_PROPERTY,
	TOGGLE_BOX_DEFAULT_KEY_PROPERTY,
	TOGGLE_BOX_STARTING_KEY_PROPERTY,
	TOGGLE_BOX_SELECTED_KEY_PROPERTY,
	TOGGLE_BOX_NUM_PROPERTIES
};
static GParamSpec* toggle_box_properties[TOGGLE_BOX_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_FLAT_BUTTON (flat_button_get_type ())
#define FLAT_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FLAT_BUTTON, FlatButton))
#define FLAT_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FLAT_BUTTON, FlatButtonClass))
#define IS_FLAT_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FLAT_BUTTON))
#define IS_FLAT_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FLAT_BUTTON))
#define FLAT_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FLAT_BUTTON, FlatButtonClass))

typedef struct _FlatButton FlatButton;
typedef struct _FlatButtonClass FlatButtonClass;

#define TYPE_CACHED_IMAGE (cached_image_get_type ())
#define CACHED_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CACHED_IMAGE, CachedImage))
#define CACHED_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CACHED_IMAGE, CachedImageClass))
#define IS_CACHED_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CACHED_IMAGE))
#define IS_CACHED_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CACHED_IMAGE))
#define CACHED_IMAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CACHED_IMAGE, CachedImageClass))

typedef struct _CachedImage CachedImage;
typedef struct _CachedImageClass CachedImageClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _ToggleBox {
	GtkBox parent_instance;
	ToggleBoxPrivate * priv;
};

struct _ToggleBoxClass {
	GtkBoxClass parent_class;
};

struct _ToggleBoxPrivate {
	gchar* _default_key;
	gchar* _starting_key;
	gchar* _selected_key;
	GtkButton* selected_button;
};


static gpointer toggle_box_parent_class = NULL;

GType toggle_box_get_type (void) G_GNUC_CONST;
#define TOGGLE_BOX_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TOGGLE_BOX, ToggleBoxPrivate))
ToggleBox* toggle_box_new (const gchar* default_key,
                           const gchar* starting_key);
ToggleBox* toggle_box_construct (GType object_type,
                                 const gchar* default_key,
                                 const gchar* starting_key);
void toggle_box_add_item (ToggleBox* self,
                          const gchar* key,
                          const gchar* label,
                          GdkPixbuf* icon);
static GtkButton* toggle_box_make_button (ToggleBox* self,
                                   const gchar* key,
                                   const gchar* name_in,
                                   GdkPixbuf* icon);
const gchar* toggle_box_get_starting_key (ToggleBox* self);
const gchar* toggle_box_get_default_key (ToggleBox* self);
static void toggle_box_select (ToggleBox* self,
                        GtkButton* button);
static gboolean toggle_box_real_draw (GtkWidget* base,
                               cairo_t* c);
void cairo_utils_rounded_rectangle (cairo_t* c,
                                    gdouble x,
                                    gdouble y,
                                    gdouble width,
                                    gdouble height,
                                    gdouble radius);
#define grid_size 40
void toggle_box_set_selected_key (ToggleBox* self,
                                  const gchar* value);
GType flat_button_get_type (void) G_GNUC_CONST;
FlatButton* flat_button_new (void);
FlatButton* flat_button_construct (GType object_type);
static void toggle_box_button_clicked_cb (ToggleBox* self,
                                   GtkButton* button);
static void _toggle_box_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self);
GType cached_image_get_type (void) G_GNUC_CONST;
CachedImage* cached_image_new (GdkPixbuf* pixbuf);
CachedImage* cached_image_construct (GType object_type,
                                     GdkPixbuf* pixbuf);
static void toggle_box_real_grab_focus (GtkWidget* base);
static void toggle_box_set_default_key (ToggleBox* self,
                                 const gchar* value);
static void toggle_box_set_starting_key (ToggleBox* self,
                                  const gchar* value);
const gchar* toggle_box_get_selected_key (ToggleBox* self);
static GObject * toggle_box_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties);
static void toggle_box_finalize (GObject * obj);
static void _vala_toggle_box_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_toggle_box_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);


ToggleBox*
toggle_box_construct (GType object_type,
                      const gchar* default_key,
                      const gchar* starting_key)
{
	ToggleBox * self = NULL;
#line 28 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	self = (ToggleBox*) g_object_new (object_type, "default-key", default_key, "starting-key", starting_key, "selected-key", starting_key, NULL);
#line 26 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	return self;
#line 169 "toggle-box.c"
}


ToggleBox*
toggle_box_new (const gchar* default_key,
                const gchar* starting_key)
{
#line 26 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	return toggle_box_construct (TYPE_TOGGLE_BOX, default_key, starting_key);
#line 179 "toggle-box.c"
}


void
toggle_box_add_item (ToggleBox* self,
                     const gchar* key,
                     const gchar* label,
                     GdkPixbuf* icon)
{
	GtkButton* item = NULL;
	GtkButton* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GList* _tmp3_;
	GList* _tmp4_;
	gboolean _tmp5_;
	GtkButton* _tmp11_;
	GtkButton* _tmp12_;
#line 32 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	g_return_if_fail (self != NULL);
#line 32 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	g_return_if_fail (key != NULL);
#line 32 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	g_return_if_fail (label != NULL);
#line 34 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp0_ = toggle_box_make_button (self, key, label, icon);
#line 34 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	item = _tmp0_;
#line 36 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp3_ = gtk_container_get_children ((GtkContainer*) self);
#line 36 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp4_ = _tmp3_;
#line 36 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp5_ = _tmp4_ == NULL;
#line 36 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	(_tmp4_ == NULL) ? NULL : (_tmp4_ = (g_list_free (_tmp4_), NULL));
#line 36 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	if (_tmp5_) {
#line 36 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_tmp2_ = TRUE;
#line 220 "toggle-box.c"
	} else {
		gboolean _tmp6_ = FALSE;
		const gchar* _tmp7_;
#line 37 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_tmp7_ = self->priv->_starting_key;
#line 37 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		if (_tmp7_ == NULL) {
#line 228 "toggle-box.c"
			const gchar* _tmp8_;
#line 37 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
			_tmp8_ = self->priv->_default_key;
#line 37 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
			_tmp6_ = g_strcmp0 (_tmp8_, key) == 0;
#line 234 "toggle-box.c"
		} else {
#line 37 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
			_tmp6_ = FALSE;
#line 238 "toggle-box.c"
		}
#line 37 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_tmp2_ = _tmp6_;
#line 242 "toggle-box.c"
	}
#line 36 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	if (_tmp2_) {
#line 36 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_tmp1_ = TRUE;
#line 248 "toggle-box.c"
	} else {
		const gchar* _tmp9_;
#line 38 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_tmp9_ = self->priv->_starting_key;
#line 38 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_tmp1_ = g_strcmp0 (_tmp9_, key) == 0;
#line 255 "toggle-box.c"
	}
#line 36 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	if (_tmp1_) {
#line 259 "toggle-box.c"
		GtkButton* _tmp10_;
#line 39 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_tmp10_ = item;
#line 39 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		toggle_box_select (self, _tmp10_);
#line 265 "toggle-box.c"
	}
#line 41 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp11_ = item;
#line 41 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	gtk_widget_show ((GtkWidget*) _tmp11_);
#line 42 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp12_ = item;
#line 42 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp12_);
#line 32 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_g_object_unref0 (item);
#line 277 "toggle-box.c"
}


static gboolean
toggle_box_real_draw (GtkWidget* base,
                      cairo_t* c)
{
	ToggleBox * self;
	gboolean result = FALSE;
	GtkAllocation allocation = {0};
	GtkAllocation _tmp0_ = {0};
	GtkAllocation _tmp1_;
	gint _tmp2_;
	GtkAllocation _tmp3_;
	gint _tmp4_;
#line 52 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	self = (ToggleBox*) base;
#line 52 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	g_return_val_if_fail (c != NULL, FALSE);
#line 55 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp0_);
#line 55 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	allocation = _tmp0_;
#line 57 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp1_ = allocation;
#line 57 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp2_ = _tmp1_.width;
#line 57 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp3_ = allocation;
#line 57 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp4_ = _tmp3_.height;
#line 57 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	cairo_utils_rounded_rectangle (c, (gdouble) 0, (gdouble) 0, (gdouble) _tmp2_, (gdouble) _tmp4_, 0.1 * grid_size);
#line 59 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	cairo_set_source_rgba (c, 0.5, 0.5, 0.5, 0.5);
#line 60 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	cairo_set_line_width (c, (gdouble) 1);
#line 61 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	cairo_stroke (c);
#line 63 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	result = GTK_WIDGET_CLASS (toggle_box_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_box_get_type (), GtkBox), c);
#line 63 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	return result;
#line 321 "toggle-box.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 73 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	return self ? g_object_ref (self) : NULL;
#line 330 "toggle-box.c"
}


static void
toggle_box_select (ToggleBox* self,
                   GtkButton* button)
{
	GtkButton* _tmp0_;
	GtkButton* _tmp4_;
	GtkButton* _tmp5_;
	GtkButton* _tmp6_;
	GtkStyleContext* _tmp7_;
	GtkButton* _tmp8_;
	gconstpointer _tmp9_;
#line 66 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	g_return_if_fail (self != NULL);
#line 66 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	g_return_if_fail (button != NULL);
#line 68 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp0_ = self->priv->selected_button;
#line 68 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	if (_tmp0_ != NULL) {
#line 353 "toggle-box.c"
		GtkButton* _tmp1_;
		GtkButton* _tmp2_;
		GtkStyleContext* _tmp3_;
#line 70 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_tmp1_ = self->priv->selected_button;
#line 70 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		gtk_button_set_relief (_tmp1_, GTK_RELIEF_NONE);
#line 71 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_tmp2_ = self->priv->selected_button;
#line 71 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
#line 71 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		gtk_style_context_remove_class (_tmp3_, "selected");
#line 367 "toggle-box.c"
	}
#line 73 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp4_ = _g_object_ref0 (button);
#line 73 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_g_object_unref0 (self->priv->selected_button);
#line 73 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	self->priv->selected_button = _tmp4_;
#line 74 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp5_ = self->priv->selected_button;
#line 74 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	gtk_button_set_relief (_tmp5_, GTK_RELIEF_NORMAL);
#line 75 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp6_ = self->priv->selected_button;
#line 75 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) _tmp6_);
#line 75 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	gtk_style_context_add_class (_tmp7_, "selected");
#line 76 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp8_ = self->priv->selected_button;
#line 76 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp9_ = g_object_get_data ((GObject*) _tmp8_, "toggle-list-key");
#line 76 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	toggle_box_set_selected_key (self, (const gchar*) _tmp9_);
#line 391 "toggle-box.c"
}


static void
_toggle_box_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self)
{
#line 84 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	toggle_box_button_clicked_cb ((ToggleBox*) self, _sender);
#line 401 "toggle-box.c"
}


static GtkButton*
toggle_box_make_button (ToggleBox* self,
                        const gchar* key,
                        const gchar* name_in,
                        GdkPixbuf* icon)
{
	GtkButton* result = NULL;
	FlatButton* item = NULL;
	FlatButton* _tmp0_;
	FlatButton* _tmp1_;
	GtkStyleContext* _tmp2_;
	FlatButton* _tmp3_;
	FlatButton* _tmp4_;
	GtkBox* hbox = NULL;
	GtkBox* _tmp5_;
	gchar* name = NULL;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	GtkLabel* label = NULL;
	GtkLabel* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	GtkBox* _tmp17_;
	FlatButton* _tmp18_;
	FlatButton* _tmp19_;
	GtkBox* _tmp20_;
	GtkBox* _tmp21_;
	FlatButton* _tmp27_;
	gchar* _tmp28_;
	GError * _inner_error_ = NULL;
#line 79 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 79 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 79 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	g_return_val_if_fail (name_in != NULL, NULL);
#line 81 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp0_ = flat_button_new ();
#line 81 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	g_object_ref_sink (_tmp0_);
#line 81 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	item = _tmp0_;
#line 82 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp1_ = item;
#line 82 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
#line 82 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	gtk_style_context_add_class (_tmp2_, "toggle-button");
#line 83 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp3_ = item;
#line 83 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	gtk_button_set_relief ((GtkButton*) _tmp3_, GTK_RELIEF_NONE);
#line 84 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp4_ = item;
#line 84 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	g_signal_connect_object ((GtkButton*) _tmp4_, "clicked", (GCallback) _toggle_box_button_clicked_cb_gtk_button_clicked, self, 0);
#line 86 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp5_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 86 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	g_object_ref_sink (_tmp5_);
#line 86 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	hbox = _tmp5_;
#line 88 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	if (icon != NULL) {
#line 470 "toggle-box.c"
		CachedImage* image = NULL;
		CachedImage* _tmp6_;
		GtkBox* _tmp7_;
		CachedImage* _tmp8_;
#line 90 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_tmp6_ = cached_image_new (icon);
#line 90 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		g_object_ref_sink (_tmp6_);
#line 90 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		image = _tmp6_;
#line 91 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_tmp7_ = hbox;
#line 91 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_tmp8_ = image;
#line 91 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		gtk_box_pack_start (_tmp7_, (GtkWidget*) _tmp8_, FALSE, FALSE, (guint) 0);
#line 88 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_g_object_unref0 (image);
#line 489 "toggle-box.c"
	}
#line 94 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp9_ = g_strdup (name_in);
#line 94 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	name = _tmp9_;
#line 95 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp10_ = self->priv->_default_key;
#line 95 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	if (g_strcmp0 (key, _tmp10_) == 0) {
#line 499 "toggle-box.c"
		const gchar* _tmp11_;
		gchar* _tmp12_;
#line 98 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_tmp11_ = name;
#line 98 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_tmp12_ = g_strdup_printf (_ ("%s (Default)"), _tmp11_);
#line 98 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_g_free0 (name);
#line 98 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		name = _tmp12_;
#line 510 "toggle-box.c"
	}
#line 101 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp13_ = (GtkLabel*) gtk_label_new (NULL);
#line 101 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	g_object_ref_sink (_tmp13_);
#line 101 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	label = _tmp13_;
#line 102 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp14_ = name;
#line 102 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp15_ = g_strdup_printf ("<span font=\"Ubuntu 13\">%s</span>", _tmp14_);
#line 102 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp16_ = _tmp15_;
#line 102 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	gtk_label_set_markup (label, _tmp16_);
#line 102 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_g_free0 (_tmp16_);
#line 103 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	gtk_widget_set_halign ((GtkWidget*) label, GTK_ALIGN_START);
#line 104 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp17_ = hbox;
#line 104 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	gtk_box_pack_start (_tmp17_, (GtkWidget*) label, TRUE, TRUE, (guint) 0);
#line 106 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp18_ = item;
#line 106 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp18_, TRUE);
#line 107 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp19_ = item;
#line 107 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp20_ = hbox;
#line 107 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	gtk_container_add ((GtkContainer*) _tmp19_, (GtkWidget*) _tmp20_);
#line 108 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp21_ = hbox;
#line 108 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp21_);
#line 548 "toggle-box.c"
	{
		GtkCssProvider* style = NULL;
		GtkCssProvider* _tmp22_;
		FlatButton* _tmp23_;
		GtkStyleContext* _tmp24_;
#line 113 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_tmp22_ = gtk_css_provider_new ();
#line 113 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		style = _tmp22_;
#line 114 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		gtk_css_provider_load_from_data (style, "* {padding: 8px;}", (gssize) -1, &_inner_error_);
#line 114 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 114 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
			_g_object_unref0 (style);
#line 564 "toggle-box.c"
			goto __catch34_g_error;
		}
#line 115 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_tmp23_ = item;
#line 115 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_tmp24_ = gtk_widget_get_style_context ((GtkWidget*) _tmp23_);
#line 115 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		gtk_style_context_add_provider (_tmp24_, (GtkStyleProvider*) style, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 110 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_g_object_unref0 (style);
#line 575 "toggle-box.c"
	}
	goto __finally34;
	__catch34_g_error:
	{
		GError* e = NULL;
		GError* _tmp25_;
		const gchar* _tmp26_;
#line 110 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		e = _inner_error_;
#line 110 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_inner_error_ = NULL;
#line 119 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_tmp25_ = e;
#line 119 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_tmp26_ = _tmp25_->message;
#line 119 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		g_debug ("toggle-box.vala:119: Internal error loading session chooser style: %s", _tmp26_);
#line 110 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_g_error_free0 (e);
#line 595 "toggle-box.c"
	}
	__finally34:
#line 110 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 110 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_g_object_unref0 (label);
#line 110 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_g_free0 (name);
#line 110 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_g_object_unref0 (hbox);
#line 110 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_g_object_unref0 (item);
#line 110 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 110 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		g_clear_error (&_inner_error_);
#line 110 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		return NULL;
#line 614 "toggle-box.c"
	}
#line 122 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp27_ = item;
#line 122 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp28_ = g_strdup (key);
#line 122 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	g_object_set_data_full ((GObject*) _tmp27_, "toggle-list-key", _tmp28_, g_free);
#line 123 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	result = (GtkButton*) item;
#line 123 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_g_object_unref0 (label);
#line 123 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_g_free0 (name);
#line 123 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_g_object_unref0 (hbox);
#line 123 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	return result;
#line 632 "toggle-box.c"
}


static void
toggle_box_button_clicked_cb (ToggleBox* self,
                              GtkButton* button)
{
	gconstpointer _tmp0_;
#line 126 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	g_return_if_fail (self != NULL);
#line 126 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	g_return_if_fail (button != NULL);
#line 128 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp0_ = g_object_get_data ((GObject*) button, "toggle-list-key");
#line 128 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	toggle_box_set_selected_key (self, (const gchar*) _tmp0_);
#line 649 "toggle-box.c"
}


static void
toggle_box_real_grab_focus (GtkWidget* base)
{
	ToggleBox * self;
	GtkButton* _tmp0_;
#line 131 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	self = (ToggleBox*) base;
#line 133 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp0_ = self->priv->selected_button;
#line 133 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	if (_tmp0_ != NULL) {
#line 664 "toggle-box.c"
		GtkButton* _tmp1_;
#line 134 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_tmp1_ = self->priv->selected_button;
#line 134 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp1_);
#line 670 "toggle-box.c"
	}
}


const gchar*
toggle_box_get_default_key (ToggleBox* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 22 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 22 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp0_ = self->priv->_default_key;
#line 22 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	result = _tmp0_;
#line 22 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	return result;
#line 688 "toggle-box.c"
}


static void
toggle_box_set_default_key (ToggleBox* self,
                            const gchar* value)
{
#line 22 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	g_return_if_fail (self != NULL);
#line 22 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	if (g_strcmp0 (value, toggle_box_get_default_key (self)) != 0) {
#line 700 "toggle-box.c"
		gchar* _tmp0_;
#line 22 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_tmp0_ = g_strdup (value);
#line 22 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_g_free0 (self->priv->_default_key);
#line 22 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		self->priv->_default_key = _tmp0_;
#line 22 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		g_object_notify_by_pspec ((GObject *) self, toggle_box_properties[TOGGLE_BOX_DEFAULT_KEY_PROPERTY]);
#line 710 "toggle-box.c"
	}
}


const gchar*
toggle_box_get_starting_key (ToggleBox* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 23 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp0_ = self->priv->_starting_key;
#line 23 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	result = _tmp0_;
#line 23 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	return result;
#line 728 "toggle-box.c"
}


static void
toggle_box_set_starting_key (ToggleBox* self,
                             const gchar* value)
{
#line 23 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	g_return_if_fail (self != NULL);
#line 23 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	if (g_strcmp0 (value, toggle_box_get_starting_key (self)) != 0) {
#line 740 "toggle-box.c"
		gchar* _tmp0_;
#line 23 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_tmp0_ = g_strdup (value);
#line 23 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_g_free0 (self->priv->_starting_key);
#line 23 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		self->priv->_starting_key = _tmp0_;
#line 23 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		g_object_notify_by_pspec ((GObject *) self, toggle_box_properties[TOGGLE_BOX_STARTING_KEY_PROPERTY]);
#line 750 "toggle-box.c"
	}
}


const gchar*
toggle_box_get_selected_key (ToggleBox* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 24 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_tmp0_ = self->priv->_selected_key;
#line 24 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	result = _tmp0_;
#line 24 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	return result;
#line 768 "toggle-box.c"
}


void
toggle_box_set_selected_key (ToggleBox* self,
                             const gchar* value)
{
#line 24 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	g_return_if_fail (self != NULL);
#line 24 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	if (g_strcmp0 (value, toggle_box_get_selected_key (self)) != 0) {
#line 780 "toggle-box.c"
		gchar* _tmp0_;
#line 24 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_tmp0_ = g_strdup (value);
#line 24 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		_g_free0 (self->priv->_selected_key);
#line 24 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		self->priv->_selected_key = _tmp0_;
#line 24 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		g_object_notify_by_pspec ((GObject *) self, toggle_box_properties[TOGGLE_BOX_SELECTED_KEY_PROPERTY]);
#line 790 "toggle-box.c"
	}
}


static GObject *
toggle_box_constructor (GType type,
                        guint n_construct_properties,
                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ToggleBox * self;
#line 47 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	parent_class = G_OBJECT_CLASS (toggle_box_parent_class);
#line 47 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 47 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TOGGLE_BOX, ToggleBox);
#line 49 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
#line 47 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	return obj;
#line 813 "toggle-box.c"
}


static void
toggle_box_class_init (ToggleBoxClass * klass)
{
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	toggle_box_parent_class = g_type_class_peek_parent (klass);
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	g_type_class_add_private (klass, sizeof (ToggleBoxPrivate));
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget *, cairo_t*)) toggle_box_real_draw;
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	((GtkWidgetClass *) klass)->grab_focus = (void (*) (GtkWidget *)) toggle_box_real_grab_focus;
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_toggle_box_get_property;
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_toggle_box_set_property;
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	G_OBJECT_CLASS (klass)->constructor = toggle_box_constructor;
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	G_OBJECT_CLASS (klass)->finalize = toggle_box_finalize;
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TOGGLE_BOX_DEFAULT_KEY_PROPERTY, toggle_box_properties[TOGGLE_BOX_DEFAULT_KEY_PROPERTY] = g_param_spec_string ("default-key", "default-key", "default-key", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TOGGLE_BOX_STARTING_KEY_PROPERTY, toggle_box_properties[TOGGLE_BOX_STARTING_KEY_PROPERTY] = g_param_spec_string ("starting-key", "starting-key", "starting-key", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TOGGLE_BOX_SELECTED_KEY_PROPERTY, toggle_box_properties[TOGGLE_BOX_SELECTED_KEY_PROPERTY] = g_param_spec_string ("selected-key", "selected-key", "selected-key", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 842 "toggle-box.c"
}


static void
toggle_box_instance_init (ToggleBox * self)
{
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	self->priv = TOGGLE_BOX_GET_PRIVATE (self);
#line 851 "toggle-box.c"
}


static void
toggle_box_finalize (GObject * obj)
{
	ToggleBox * self;
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TOGGLE_BOX, ToggleBox);
#line 22 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_g_free0 (self->priv->_default_key);
#line 23 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_g_free0 (self->priv->_starting_key);
#line 24 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_g_free0 (self->priv->_selected_key);
#line 45 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	_g_object_unref0 (self->priv->selected_button);
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	G_OBJECT_CLASS (toggle_box_parent_class)->finalize (obj);
#line 871 "toggle-box.c"
}


GType
toggle_box_get_type (void)
{
	static volatile gsize toggle_box_type_id__volatile = 0;
	if (g_once_init_enter (&toggle_box_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ToggleBoxClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) toggle_box_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ToggleBox), 0, (GInstanceInitFunc) toggle_box_instance_init, NULL };
		GType toggle_box_type_id;
		toggle_box_type_id = g_type_register_static (gtk_box_get_type (), "ToggleBox", &g_define_type_info, 0);
		g_once_init_leave (&toggle_box_type_id__volatile, toggle_box_type_id);
	}
	return toggle_box_type_id__volatile;
}


static void
_vala_toggle_box_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	ToggleBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TOGGLE_BOX, ToggleBox);
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	switch (property_id) {
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		case TOGGLE_BOX_DEFAULT_KEY_PROPERTY:
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		g_value_set_string (value, toggle_box_get_default_key (self));
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		break;
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		case TOGGLE_BOX_STARTING_KEY_PROPERTY:
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		g_value_set_string (value, toggle_box_get_starting_key (self));
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		break;
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		case TOGGLE_BOX_SELECTED_KEY_PROPERTY:
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		g_value_set_string (value, toggle_box_get_selected_key (self));
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		break;
#line 917 "toggle-box.c"
		default:
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		break;
#line 923 "toggle-box.c"
	}
}


static void
_vala_toggle_box_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	ToggleBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TOGGLE_BOX, ToggleBox);
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
	switch (property_id) {
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		case TOGGLE_BOX_DEFAULT_KEY_PROPERTY:
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		toggle_box_set_default_key (self, g_value_get_string (value));
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		break;
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		case TOGGLE_BOX_STARTING_KEY_PROPERTY:
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		toggle_box_set_starting_key (self, g_value_get_string (value));
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		break;
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		case TOGGLE_BOX_SELECTED_KEY_PROPERTY:
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		toggle_box_set_selected_key (self, g_value_get_string (value));
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		break;
#line 956 "toggle-box.c"
		default:
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "/builddir/build/BUILD/slick-greeter-1.2.4/src/toggle-box.vala"
		break;
#line 962 "toggle-box.c"
	}
}



